package com.hai.dao;

import com.hai.entity.HighDevice;
import com.hai.entity.HighDeviceExample.Criteria;
import com.hai.entity.HighDeviceExample.Criterion;
import com.hai.entity.HighDeviceExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighDeviceSqlProvider {

    public String countByExample(HighDeviceExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_device");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighDeviceExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_device");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighDevice record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_device");
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.VALUES("company_name", "#{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreId() != null) {
            sql.VALUES("mer_store_id", "#{merStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getMerStoreName() != null) {
            sql.VALUES("mer_store_name", "#{merStoreName,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceName() != null) {
            sql.VALUES("device_name", "#{deviceName,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceSn() != null) {
            sql.VALUES("device_sn", "#{deviceSn,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceKey() != null) {
            sql.VALUES("device_key", "#{deviceKey,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceImei() != null) {
            sql.VALUES("device_imei", "#{deviceImei,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceIccid() != null) {
            sql.VALUES("device_iccid", "#{deviceIccid,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptTop() != null) {
            sql.VALUES("receipt_top", "#{receiptTop,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptSource() != null) {
            sql.VALUES("receipt_source", "#{receiptSource,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptBottom() != null) {
            sql.VALUES("receipt_bottom", "#{receiptBottom,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighDeviceExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("`type`");
        sql.SELECT("company_id");
        sql.SELECT("company_name");
        sql.SELECT("mer_id");
        sql.SELECT("mer_name");
        sql.SELECT("mer_store_id");
        sql.SELECT("mer_store_name");
        sql.SELECT("device_name");
        sql.SELECT("device_sn");
        sql.SELECT("device_key");
        sql.SELECT("device_imei");
        sql.SELECT("device_iccid");
        sql.SELECT("receipt_top");
        sql.SELECT("receipt_source");
        sql.SELECT("receipt_bottom");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_device");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighDevice record = (HighDevice) parameter.get("record");
        HighDeviceExample example = (HighDeviceExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_device");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreId() != null) {
            sql.SET("mer_store_id = #{record.merStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getMerStoreName() != null) {
            sql.SET("mer_store_name = #{record.merStoreName,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceName() != null) {
            sql.SET("device_name = #{record.deviceName,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceSn() != null) {
            sql.SET("device_sn = #{record.deviceSn,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceKey() != null) {
            sql.SET("device_key = #{record.deviceKey,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceImei() != null) {
            sql.SET("device_imei = #{record.deviceImei,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceIccid() != null) {
            sql.SET("device_iccid = #{record.deviceIccid,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptTop() != null) {
            sql.SET("receipt_top = #{record.receiptTop,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptSource() != null) {
            sql.SET("receipt_source = #{record.receiptSource,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptBottom() != null) {
            sql.SET("receipt_bottom = #{record.receiptBottom,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_device");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("mer_store_id = #{record.merStoreId,jdbcType=BIGINT}");
        sql.SET("mer_store_name = #{record.merStoreName,jdbcType=VARCHAR}");
        sql.SET("device_name = #{record.deviceName,jdbcType=VARCHAR}");
        sql.SET("device_sn = #{record.deviceSn,jdbcType=VARCHAR}");
        sql.SET("device_key = #{record.deviceKey,jdbcType=VARCHAR}");
        sql.SET("device_imei = #{record.deviceImei,jdbcType=VARCHAR}");
        sql.SET("device_iccid = #{record.deviceIccid,jdbcType=VARCHAR}");
        sql.SET("receipt_top = #{record.receiptTop,jdbcType=VARCHAR}");
        sql.SET("receipt_source = #{record.receiptSource,jdbcType=VARCHAR}");
        sql.SET("receipt_bottom = #{record.receiptBottom,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighDeviceExample example = (HighDeviceExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighDevice record) {
        SQL sql = new SQL();
        sql.UPDATE("high_device");
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerStoreId() != null) {
            sql.SET("mer_store_id = #{merStoreId,jdbcType=BIGINT}");
        }
        
        if (record.getMerStoreName() != null) {
            sql.SET("mer_store_name = #{merStoreName,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceName() != null) {
            sql.SET("device_name = #{deviceName,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceSn() != null) {
            sql.SET("device_sn = #{deviceSn,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceKey() != null) {
            sql.SET("device_key = #{deviceKey,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceImei() != null) {
            sql.SET("device_imei = #{deviceImei,jdbcType=VARCHAR}");
        }
        
        if (record.getDeviceIccid() != null) {
            sql.SET("device_iccid = #{deviceIccid,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptTop() != null) {
            sql.SET("receipt_top = #{receiptTop,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptSource() != null) {
            sql.SET("receipt_source = #{receiptSource,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiptBottom() != null) {
            sql.SET("receipt_bottom = #{receiptBottom,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighDeviceExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}